#ifndef MOSESHARDPROCESSRECORD_h
#define MOSESHARDPROCESSRECORD_h

#include "Basics.h"
#include "Event.h"
#include "mosesCommon.h"
#include "mapTObj.h"
#include "rootdict.h"

using namespace std;
using namespace Pythia8;

namespace Moses1 {


class mosesHardProcessRecord : public Particle, public mapTObj
{
        public:
		mosesHardProcessRecord(string name, TFile* file);
		~mosesHardProcessRecord();
	
		string getName() {return m_name;}
	
		bool fillRecordTree();
		bool writeRecordTree();
		bool clearHardProcessRecord();
		bool fillHardProcessRecord(Particle &particle, int pythiaIndex, int mosesIndex);

        private:
		void initialize(string name, TFile* file);
		int getStatusLevel(int status);

		string m_name;
	
		TDirectory* m_dir;

		TTree* m_hardProcessDataTree;
		
		mapTObj* m_pythia2mosesIndexMap; // int->int
		/*
		mapTObj* m_momA;        // int -> int
		mapTObj* m_momB;        // int -> int
		mapTObj* m_sonA;        // int -> int
		mapTObj* m_sonB;        // int -> int
		mapTObj* m_isFinal;     // int -> int
		mapTObj* m_statusLevel; // int -> int
		
		mapTObj* m_id;          // int -> double
		mapTObj* m_cg;          // int -> double
		mapTObj* m_m0;          // int -> double
		mapTObj* m_p0;          // int -> double
		mapTObj* m_px;          // int -> double
		mapTObj* m_py;          // int -> double
		mapTObj* m_pz;          // int -> double
		mapTObj* m_xVtx;        // int -> double
		mapTObj* m_yVtx;        // int -> double
		mapTObj* m_zVtx;        // int -> double
		*/
		
		vector<int>* m_momA;
		vector<int>* m_momB;
		vector<int>* m_sonA;
		vector<int>* m_sonB;
		vector<int>* m_isFinal;
		vector<int>* m_statusLevel;
		
		vector<int>* m_id;
		vector<double>* m_cg;
		vector<double>* m_m0;
		vector<double>* m_p0;
		vector<double>* m_px;
		vector<double>* m_py;
		vector<double>* m_pz;
		vector<double>* m_xVtx;
		vector<double>* m_yVtx;
		vector<double>* m_zVtx;
};



}

#endif
