#ifndef MOSESPARTICLERECORD_h
#define MOSESPARTICLERECORD_h

#include "Basics.h"
#include "Event.h"
#include "mosesCommon.h"

using namespace std;
using namespace Pythia8;

namespace Moses1 {


class mosesParticleRecord : public Particle
{
        public:
		mosesParticleRecord(string name, TFile* file);
        ~mosesParticleRecord();
	
		string getName() {return m_name;}
	
		bool fillRecordTree();
		bool writeRecordTree();
		bool clearParticleRecord();
		bool fillParticleRecord(Particle &particle, int isHardProcess);

        private:
		void initialize(string name, TFile* file);

		string m_name;
	
		TDirectory* m_dir;
                
		TTree* m_particleDataTree;

		vector<int>* m_isHardProcess;
		vector<int>* m_id;

		vector<double>* m_cg;
		vector<double>* m_m0;
		vector<double>* m_p0;
		vector<double>* m_px;
		vector<double>* m_py;
		vector<double>* m_pz;

		vector<double>* m_xVtx;
		vector<double>* m_yVtx;
		vector<double>* m_zVtx;
};


class eventParticles
{
        public:
		eventParticles(TTree* particleRecordTree);
		~eventParticles();		
		
		void getEntry(int particleEntry);

		unsigned int size();

		bool isHardProcess(int particleEntry);
		int  id(int particleEntry);
		double charge(int particleEntry);
		double m0(int particleEntry);
		double p0(int particleEntry);
		double px(int particleEntry);
		double py(int particleEntry);
		double pz(int particleEntry);
		double xVtx(int particleEntry);
		double yVtx(int particleEntry);
		double zVtx(int particleEntry);

        private:
		TTree* m_particleRecordTree;

		int m_size;
		vector<int>* m_isHardProcess;
		vector<int>* m_id;
		vector<double>* m_cg;
		vector<double>* m_m0;
		vector<double>* m_p0;
		vector<double>* m_px;
		vector<double>* m_py;
		vector<double>* m_pz;
		vector<double>* m_xVtx;
		vector<double>* m_yVtx;
		vector<double>* m_zVtx;
};


}

#endif
